其中一个是匿名,过滤的时候就用的匿名
BlockReference.Name 匿名
EffectiveName
http://blog.csdn.net/hisinwang/article/details/78764581
http://adndevblog.typepad.com/autocad/2012/05/ide ... from-the-block-reference.html
AutoCAD .Net 获取块参照块名
<CommandMethod("GetBlockName")> _
Public Sub GetBlockName()
Dim doc As Document = Application.DocumentManager.MdiActiveDocument
Dim db As Database = doc.Database
Dim options As New PromptEntityOptions(vbLf & "Select block reference")
options.SetRejectMessage(vbLf & "Select only block reference")
options.AddAllowedClass(GetType(BlockReference), False)
Dim ret As PromptEntityResult = doc.Editor.GetEntity(options)
If ret.Status <> PromptStatus.OK Then
Return
End If
Using tr As Transaction = db.TransactionManager.StartTransaction()
Dim blkRef As BlockReference = TryCast(tr.GetObject(ret.ObjectId, OpenMode.ForRead), BlockReference)
Dim blkRecdId As ObjectId = ObjectId.Null
If blkRef.IsDynamicBlock Then
blkRecdId = blkRef.DynamicBlockTableRecord
Else
blkRecdId = blkRef.BlockTableRecord
End If
Dim block As BlockTableRecord = TryCast(tr.GetObject(blkRecdId, OpenMode.ForRead), BlockTableRecord)
doc.Editor.WriteMessage(block.Name + vbLf)
End Using
End Sub
程序代码: |
Imports System.Collections.Generic
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Namespace EntitySelection
Public Class Commands
<CommandMethod("SDB")> _
Public Shared Sub SelectDynamicBlocks()
Dim doc As Object = Application.DocumentManager.MdiActiveDocument
Dim ed As Object = doc.Editor
Dim pso As New PromptStringOptions(vbLf & "Name of dynamic block to search for")
pso.AllowSpaces = True
Dim pr As Object = ed.GetString(pso)
If pr.Status <> PromptStatus.OK Then
Return
End If
Dim blkName As String = pr.StringResult
Dim blkNames As New List(Of String)()
blkNames.Add(blkName)
Dim tr As Object = doc.TransactionManager.StartTransaction()
Using tr
Dim bt As BlockTable = CType(tr.GetObject(doc.Database.BlockTableId, OpenMode.ForRead),BlockTable)
' Start by getting access to our block, if it exists
If Not bt.Has(blkName) Then
ed.WriteMessage(vbLf & "Cannot find block called ""{0}"".", blkName)
Return
End If
' Get the anonymous block names
Dim btr As BlockTableRecord = CType(tr.GetObject(bt(blkName), OpenMode.ForRead), BlockTableRecord)
If Not btr.IsDynamicBlock Then
ed.WriteMessage(vbLf & "Cannot find a dynamic block called ""{0}"".", blkName)
Return
End If
' Get the anonymous blocks and add them to our list
Dim anonBlks As Object = btr.GetAnonymousBlockIds()
For Each bid As ObjectId In anonBlks
Dim btr2 As BlockTableRecord = CType(tr.GetObject(bid, OpenMode.ForRead), BlockTableRecord)
blkNames.Add(btr2.Name)
Next
tr.Commit()
End Using
' Build a conditional filter list so that only
' entities with the specified properties are
' selected
Dim sf As New SelectionFilter(CreateFilterListForBlocks(blkNames))
Dim psr As PromptSelectionResult = ed.SelectAll(sf)
ed.WriteMessage(vbLf & "Found {0} entit{1}.", psr.Value.Count, (If(psr.Value.Count = 1, "y", "ies")))
End Sub
Private Shared Function CreateFilterListForBlocks(blkNames As List(Of String)) As TypedValue()
' If we don't have any block names, return null
If blkNames.Count = 0 Then
Return Nothing
End If
' If we only have one, return an array of a single value
If blkNames.Count = 1 Then
Return New TypedValue() {New TypedValue(CType(DxfCode.BlockName, Integer), blkNames(0))}
End If
' We have more than one block names to search for...
' Create a list big enough for our block names plus
' the containing "or" operators
Dim tvl As New List(Of TypedValue)(blkNames.Count + 2)
' Add the initial operator
tvl.Add(New TypedValue(CType(DxfCode.[Operator], Integer), "<or"))
' Add an entry for each block name, prefixing the
' anonymous block names with a reverse apostrophe
For Each blkName As Object In blkNames
tvl.Add(New TypedValue(CType(DxfCode.BlockName, Integer), (If(blkName.StartsWith("*"), "`" + blkName, blkName))))
Next
' Add the final operator
tvl.Add(New TypedValue(CType(DxfCode.[Operator], Integer), "or>"))
' Return an array from the list
Return tvl.ToArray()
End Function
End Class
End Namespace
[本日志由 tiancao1001 于 2019-07-02 10:44 PM 编辑]
|
暂时没有评论
发表评论 - 不要忘了输入验证码哦! |